package org.bitbucket.bradleysmithllc.etlagent.informatica.client;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

public class CreateConnectionClient {
	public static void main(String[] argv) throws Exception {
		URL url = new URL("http://bsmithvm:8188/rest/service/informatica/createInformaticaConnection");
		HttpURLConnection conn = (HttpURLConnection) url.openConnection();
		conn.setDoOutput(true);
		conn.setRequestMethod("POST");
		conn.setRequestProperty("Content-Type", "application/json");

		String input =
			"{" +
				"\"serverName\": \"localhost\"," +
				"\"databaseName\": \"dbname\"," +
				"\"databaseUserName\": \"dbuser\"," +
				"\"databasePassword\": \"dbpass\"," +
				"\"relationalConnectionName\": \"relationalName\"" +
			"}";

		OutputStream os = conn.getOutputStream();
		os.write(input.getBytes());
		os.flush();

		if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
			System.out.println(conn.getResponseMessage());
			throw new RuntimeException("Failed : HTTP error code : "
					+ conn.getResponseCode());
		}

		BufferedReader br = new BufferedReader(new InputStreamReader(
				(conn.getInputStream())));

		String output;
		System.out.println("Output from Server .... \n");
		while ((output = br.readLine()) != null) {
			System.out.println(output);
		}

		conn.disconnect();
	}
}
