package org.bitbucket.bradleysmithllc.etlagent.informatica.client;

import com.google.gson.stream.JsonWriter;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.StringWriter;
import java.net.HttpURLConnection;
import java.net.URL;

public class ExportWorklowToXmlClient {
	public static void main(String[] argv) throws Exception {
		URL url = new URL("http://bsmithvm:8188/rest/service/informatica/exportWorkflowToXml");
		HttpURLConnection conn = (HttpURLConnection) url.openConnection();
		conn.setDoOutput(true);
		conn.setRequestMethod("POST");
		conn.setRequestProperty("Content-Type", "application/json");

		StringWriter stw = new StringWriter();
		JsonWriter jwriter = new JsonWriter(stw);

		jwriter.beginObject();

		jwriter.name("folder");
		jwriter.value("__bsmithvm_test_SHARED_EDW");

		jwriter.name("workflow-name");
		jwriter.value("wkf_INT_CONVERSION_TEST");

		jwriter.endObject();

		jwriter.close();

		OutputStream os = conn.getOutputStream();
		os.write(stw.toString().getBytes());
		os.flush();

		if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
			System.out.println(conn.getResponseMessage());
			throw new RuntimeException("Failed : HTTP error code : "
					+ conn.getResponseCode());
		}

		BufferedReader br = new BufferedReader(new InputStreamReader(
				(conn.getInputStream())));

		String output;
		System.out.println("Output from Server .... \n");
		while ((output = br.readLine()) != null) {
			System.out.println(output);
		}

		conn.disconnect();
	}
}
