package org.bitbucket.bradleysmithllc.etlagent.informatica.client;

import com.google.gson.stream.JsonWriter;
import org.apache.commons.io.FileUtils;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;

public class ImportWorklowFromXmlClient {
	public static void main(String[] argv) throws Exception {
		URL url = new URL("http://bsmithvm:8188/rest/service/informatica/importWorkflowFromXml");
		HttpURLConnection conn = (HttpURLConnection) url.openConnection();
		conn.setDoOutput(true);
		conn.setRequestMethod("POST");
		conn.setRequestProperty("Content-Type", "application/json");

		File src = new File("/Users/bsmith/git/etl-unit/integration/informatica-integration-test/src/main/informatica/SHARED_EDW/wkf_INT_CONVERSION_TEST.xml");

		String srcXml = FileUtils.readFileToString(src);

		StringWriter stw = new StringWriter();
		JsonWriter jwriter = new JsonWriter(stw);

		jwriter.beginObject();

		jwriter.name("folder-prefix");
		jwriter.value("__bsmithvm_test");

		jwriter.name("workflow-name");
		jwriter.value(src.getName());

		jwriter.name("workflow-xml");
		jwriter.value(srcXml);

		jwriter.endObject();

		jwriter.close();

		OutputStream os = conn.getOutputStream();
		os.write(stw.toString().getBytes());
		os.flush();

		if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
			System.out.println(conn.getResponseMessage());
			throw new RuntimeException("Failed : HTTP error code : "
					+ conn.getResponseCode());
		}

		BufferedReader br = new BufferedReader(new InputStreamReader(
				(conn.getInputStream())));

		String output;
		System.out.println("Output from Server .... \n");
		while ((output = br.readLine()) != null) {
			System.out.println(output);
		}

		conn.disconnect();
	}
}
